View Issue Details

IDProjectCategoryView StatusLast Update
0031247LazarusLCLpublic2017-10-16 22:53
ReporterArmin LinderAssigned ToMichl 
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionfixed 
PlatformOSWindowsOS Version7,10
Product Version1.6.2Product Build 
Target Version1.6.4Fixed in Version1.7 (SVN) 
Summary0031247: LCL TComboBox: modifier key triggers dropdown list
DescriptionWhen using AutoDropDown, a modifier key KeyDown event triggers the dropdown.
Steps To ReproducePut a TCombobox on a form, put the cursor in the edit field, press any modifier key (shift, alt ...), and the Combobox drops down.

This is a deviation from Delphi, and it does severely hamper tabbing through forms (shift-Tab triggers dropdown instead of move focus)
TagsNo tags attached.
Fixed in Revisionr54054, r54056
LazTarget-
WidgetsetWin32/Win64
Attached Files

Relationships

related to 0031308 closedMichl Combobox: Left-arrow deviation 
related to 0031309 closedMichl Combobox: Backspace deviation 
related to 0031331 closedMichl Combobox: cannot select text by shift+left/right (Autodropdown) 
related to 0032559 closedMichl Tabulator isn't working for ComboBox and style csSimple 

Activities

Armin Linder

2017-01-27 11:15

reporter   ~0097729

More bugs/deviations compared with Delphi found.

- if you position the cursor in the text using the mouse, and press [Left-Arrow] to advance the cursor left, the cursor jumps to the end of the field instead, and advances 1 character left from there

- if you position the cursor in the text, using the mouse, and click to clear the autoselect, then press [Backspace] to delete a character left, the whole text field is deleted

For full description see forum post:
http://forum.lazarus.freepascal.org/index.php?topic=35465.msg235494#msg235494

Armin Linder

2017-01-27 11:19

reporter   ~0097730

Last edited: 2017-01-27 11:20

View 2 revisions

Another issue found is that the Lazarus version does provide some sort of case-insensitivity (cbactRetainPrefixCase:true, cbactearchCaseSensitive:true) which Delphi does not offer, but it seems not implemented properly: the attributes are correctly honored on text entry, but not on exit control. If you enter any text differing in case only from one of the items, the item is not selected during text entry, but it is selected on exit.

Michl

2017-01-27 13:56

developer   ~0097734

Last edited: 2017-01-27 13:56

View 2 revisions

Please one bugreport for one issue. It is not guaranteed that one developer will fix all issues or only one and than this report is hard to read or bugs/features are forgotten.

Thank you

Michl

2017-01-31 21:18

developer   ~0097851

Last edited: 2017-02-01 12:09

View 2 revisions

> press any modifier key (shift, alt ...), and the Combobox drops down.

Fixed in trunk revision 54045, 54053.

Alexey Tor.

2017-02-01 01:36

reporter   ~0097854

See also 2 new issues from comments.

Michl

2017-02-01 12:14

developer  

combobox1.zip (1,892 bytes)

Michl

2017-02-01 12:24

developer   ~0097866

> if you position the cursor in the text, using the mouse, and click to clear the
> autoselect, then press [Backspace] to delete a character left, the whole text
> field is deleted

Fixed for Win32 in trunk revision 54054. GTK2 is further broken, later I'll see, if I can fix that too.

Michl

2017-02-01 12:38

developer   ~0097867

> if you position the cursor in the text using the mouse, and press [Left-Arrow]
> to advance the cursor left, the cursor jumps to the end of the field instead,
> and advances 1 character left from there

This, I can't see. Can you check the added example combobox1.zip with latest trunk, if it shows that behaviour?

If it shows that behaviour, please explain it step by step, maybe I miss something.

Michl

2017-02-01 12:43

developer   ~0097868

Last edited: 2017-02-01 12:50

View 3 revisions

> Another issue found is that the Lazarus version does provide some sort of
> case-insensitivity (cbactRetainPrefixCase:true, cbactearchCaseSensitive:true)
> which Delphi does not offer, but it seems not implemented properly: the
> attributes are correctly honored on text entry, but not on exit control. If you
> enter any text differing in case only from one of the items, the item is not
> selected during text entry, but it is selected on exit.

Fixed in trunk revision 54054.

Alexey Tor.

2017-02-01 13:03

reporter   ~0097869

//Related: 0031308, 0031309

Alexey Tor.

2017-02-01 13:21

reporter   ~0097870

Left-arrow issue: Dont see it too, on Win10 and posted demo zip..
I see issue4:

on this demo zip, focus combobox by mouse, then move caret, and press AltF4. App dont close. AltF4 dont work.

Michl

2017-02-01 15:22

developer   ~0097879

> I see issue4:

> on this demo zip, focus combobox by mouse, then move caret, and press AltF4.
> App dont close. AltF4 dont work.

If you find a bug, please open a new bugreport!!!

I fixed this issue in trunk revision 54055 (now it should be Delphi compatible, <Alt> + <F4> works, if DropDownWindow isn't opened).

Alexey Tor.

2017-02-01 15:31

reporter   ~0097880

Sorry:I should have new report for this

Michl

2017-02-01 17:20

developer   ~0097887

Fixed in trunk revision 54054. Please test and close if ok.

Issue History

Date Modified Username Field Change
2017-01-18 10:32 Armin Linder New Issue
2017-01-27 11:15 Armin Linder Note Added: 0097729
2017-01-27 11:19 Armin Linder Note Added: 0097730
2017-01-27 11:20 Armin Linder Note Edited: 0097730 View Revisions
2017-01-27 13:56 Michl Note Added: 0097734
2017-01-27 13:56 Michl Note Edited: 0097734 View Revisions
2017-01-31 21:12 Michl Assigned To => Michl
2017-01-31 21:12 Michl Status new => assigned
2017-01-31 21:18 Michl Note Added: 0097851
2017-02-01 01:36 Alexey Tor. Note Added: 0097854
2017-02-01 12:09 Michl Note Edited: 0097851 View Revisions
2017-02-01 12:14 Michl File Added: combobox1.zip
2017-02-01 12:24 Michl Note Added: 0097866
2017-02-01 12:38 Michl LazTarget => -
2017-02-01 12:38 Michl Note Added: 0097867
2017-02-01 12:38 Michl Status assigned => feedback
2017-02-01 12:43 Michl Note Added: 0097868
2017-02-01 12:47 Michl Note Edited: 0097868 View Revisions
2017-02-01 12:50 Michl Note Edited: 0097868 View Revisions
2017-02-01 13:03 Alexey Tor. Note Added: 0097869
2017-02-01 13:21 Alexey Tor. Note Added: 0097870
2017-02-01 14:29 Michl Relationship added related to 0031308
2017-02-01 14:32 Michl Relationship added related to 0031309
2017-02-01 15:22 Michl Note Added: 0097879
2017-02-01 15:31 Alexey Tor. Note Added: 0097880
2017-02-01 17:20 Michl Fixed in Revision => r54054
2017-02-01 17:20 Michl Note Added: 0097887
2017-02-01 17:20 Michl Status feedback => resolved
2017-02-01 17:20 Michl Fixed in Version => 1.7 (SVN)
2017-02-01 17:20 Michl Resolution open => fixed
2017-02-01 17:20 Michl Target Version => 1.6.4
2017-02-01 20:25 Michl Relationship added related to 0031331
2017-02-01 20:48 Michl Fixed in Revision r54054 => r54054, r54056
2017-10-16 22:53 Michl Relationship added related to 0032559